package cz.cvut.fit.xml.index.tpa.examples;

import cz.cvut.fit.xml.index.tpa.AutomatonFactory;
import cz.cvut.fit.xml.index.tpa.DocumentLoader;
import cz.cvut.fit.xml.index.tpa.TreePathsAutomaton;
import java.io.File;
import java.io.IOException;
import java.util.LinkedList;
import java.util.TreeSet;
import org.jdom2.Document;
import org.jdom2.Element;
import org.jdom2.JDOMException;

/**
 * Example usage of tpalib-1.0.
 *
 * @author eliska.sestakova@fit.cvut.cz
 */
public class TPAExample1 {

    public static void main(String[] args) throws IOException, JDOMException {
        TreePathsAutomaton automaton;

        String path = "GoT.xml";
        String query = "//HOUSE/LORD";

        Document document = (new DocumentLoader()).load(path);

        //if the automaton was built before
        if (new File(path + ".ser").isFile()) {
            //use it
            automaton = (new AutomatonFactory()).deserealize(path + ".ser");
        } else {
            //build it and save it
            automaton = (new AutomatonFactory()).build(document);
            automaton.serialize(path + ".ser");
        }

        automaton.dump();

        //************************** QUERIES ***********************************
        //get the list of XML elements satisfying the query
        LinkedList<Element> result1 = automaton.evaluate(query);
        System.out.println("Result:" + result1);

        //get the occurrences
        TreeSet<Integer> dsubset = automaton.getDSubset(query);
        System.out.println("d-subset: " + dsubset);
        //maps the content of dsubset to individual XML elements
        LinkedList<Element> result2 = automaton.evaluate(dsubset);

        /*
        result1.stream().forEach((element) -> {
            //DO STUFF WITH ELEMENTS
        });
         */
    }
}
