package cz.cvut.fit.xml.index.tpa;

import java.io.FileInputStream;
import java.io.IOException;
import org.jdom2.Document;
import org.jdom2.JDOMException;
import org.jdom2.input.SAXBuilder;

/**
 * XML Documents Loader.
 *
 * @author sestaeli
 */
public class DocumentLoader {

    private final SAXBuilder builder;

    /**
     * Constructs new <code>DocumentLoader</code>.
     */
    public DocumentLoader() {
        builder = new SAXBuilder();
    }

    /**
     *
     * @param file name of XML file to be loaded
     * @return resultant Document object
     * @throws JDOMException when errors occur in parsing
     * @throws IOException when an I/O error prevents a document from being
     * fully parsed
     */
    public Document load(String file) throws JDOMException, IOException {
        return builder.build(new FileInputStream(file));
    }
}
